/*      
        alph: Piper program implementing and analysing traditional and
        historic c(ai)phers designed to be used in conjuction with other
	      programs.

        Copyright (C) 2004  Corcalciuc V. Horia

        This library is free software; you can redistribute it and/or
        modify it under the terms of the GNU Lesser General Public
        License as published by the Free Software Foundation; either
        version 2.1 of the License, or (at your option) any later version.

        This library is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
        Lesser General Public License for more details.

        You should have received a copy of the GNU Lesser General Public
        License along with this library; if not, write to the Free Software
        Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

*/



#include "alphCRYPT.h"

int
morse(char *org)
{
  int itra, itrb;
  char *dst;
  char *mgt;
  
  char *ma[] = { ".-", "-...", "-.-.", "-..", ".",
                   "..-.", "--.", "....", "..", ".---",
                   "-.-", ".-..", "--", "-.", "---", ".--.",
                   "--.-", ".-.", "...", "-", "..-", "...-",
                   ".--", "-..-", "-.--", "--.."};

  char *md[] = { "-----", ".----", "..---", "...--", "....-", ".....",
                 "-....", "--...", "---..", "----.", "----." };

  char *mp[] = { ".-.-.-", "--..--", "---...", "..--..", ".----.",
                 "-....-", "-..-.", "-.--.-", ".-..-.", ".--.-.",
                 ".--.-.", "-...-" };

  const char *spc=" ";
  
  dst = (char *) calloc(strlen(org)*4, sizeof(char));
  mgt = (char *) calloc(5, sizeof(char));
  
  if(!al_dec)
    for(itra=0; itra<strlen(org)-1; itra++)
      {
        if(isupper(org[itra]))
          org[itra]=tolower(org[itra]);
        if(isalpha(org[itra]))
          strcat(dst, ma[org[itra]-'a']);
        else if(isdigit(org[itra]))
          strcat(dst, md[org[itra]-'0']);
        else if(ispunct(org[itra]))
          switch(org[itra])
            {
              case '.':
                strcat(dst, mp[0]);
                break;
              case ',':
                strcat(dst, mp[1]);
                break;
              case ';':
                strcat(dst, mp[2]);
                break;
              case '?':
                strcat(dst, mp[3]);
                break;
              case '\'':
                strcat(dst, mp[4]);
                break;
              case '-':
                strcat(dst, mp[5]);
                break;
              case '/':
                strcat(dst, mp[6]);
                break;
              case '(':
              case ')':
                strcat(dst, mp[7]);
                break;
              case '\"':
                strcat(dst, mp[8]);
                break;
              case '@':
                strcat(dst, mp[9]);
                break;
              case '=':
                strcat(dst, mp[10]);
                break;
            }
        strcat(dst, spc);
      }

  if(org[strlen(org)-1]=='\n')
    dst[strlen(dst)-1]='\n';
  strncpy(org, dst, strlen(dst));
  free(dst);

  return 0;;
      
}
          
